        program  so_cal_basins
c
c program SOuthern CALifornia BASINS ---------------------
c generates so cal area basin velocities and densities ---
c version A    9-97   HMagistrale    ---------------------
c version A2   5-98   newer santa monica mts
c version A3   6-98   fixed SFV glitches
c version A4   6-98   same as A3, but code rewrite to be tidy
c version A5   6-98   corrected to fit oil well data
c                     added separate SGV file hooks,
c                      these currently reread LAB surfaces
c version A6   9-98   fixed more SFV, SMM glitches,
c                     installed 'smooth' H-K background
c                     with constant moho at 32 km
c                   
c
         include 'in.h'
         include 'surface.h'
         include 'innum.h'
         include 'back2.h'
         include 'labup.h'
         dimension inorout(ibig,isurmx),rsuqus(ibig,isurmx)
         include 'surfaced.h'
         include 'backd2.h'
c some constants
         rd2rad=3.141593/180.
         rckval=500000.
c--read points of interest file
         call readpts(kerr)
         if(kerr.eq.1)then
         write(*,*)' error with point file '
         go to 98
         endif
c--read stratigraphic surfaces---------------------------
         call readsurf(kerr)
         if(kerr.eq.1)then
         write(*,*)' error with strat files '
         go to 98
         endif
c--read surface edges------------------------------------
         call readedge(kerr)
         if(kerr.eq.1)then
         write(*,*)' error with edges files '
         go to 98
         endif
c----read model edge (realm) file----------------------
         call modedge(kerr)
         if(kerr.eq.1)then
         write(*,*)' error with model edge file '
         go to 98
         endif
c----read surface geology where needed: LAB, SAN BERDO----
         call readgeo(kerr)
         if(kerr.eq.1)then
         write(*,*)' error with surface geology file '
         go to 98
         endif
c----read uplift where needed: LAB, -------------
         call readup(kerr)
         if(kerr.eq.1)then
         write(*,*)' error with uplift file '
         go to 98
         endif
c---see whos in and out of model area realm-------------
c prepare for inside
         xref=rmodtx(i3)
         yref=rmodty(i3)
         reflat=yref*rd2rad
         do 179 i=1,i3
          y2(i) = (rmodty(i) - yref)*111.1
          x2(i) = (rmodtx(i) - xref)*111.1*cos(reflat)
179      continue
c loop over points-find whose in and out of whole model
         do 555 k=1,nn
          yp=(rlat(k)-yref)*111.1
          xp=(rlon(k)-xref)*111.1*cos(reflat)
          call inside(xp,yp,x2,y2,i3,ins)
          inout(k)=ins
555      continue
c 
c--start loop over points in question-------------------
873      do 800 l0=1,nn 
c---outside model area-give it basement or tomo--------
         if(inout(l0).eq.0)goto 980
c--find out what surface it's in and out----------------
c--prepare for inside-----------------------------------
          inct=0
          do 444 j=1,numsur
          n9=nedge(j)
          xref=rtx(j,nedge(j))
          yref=rty(j,nedge(j))
          reflat=yref*rd2rad
           do 410 i=1,nedge(j)
           yv(i)=(rty(j,i)-yref)*111.1
           xv(i)=(rtx(j,i)-xref)*111.1*cos(reflat)
410        continue
          rxp=(rlon(l0)-xref)*111.1*cos(reflat)
          ryp=(rlat(l0)-yref)*111.1
          call inside(rxp,ryp,xv,yv,n9,ins)
          if(ins.eq.1)then
           inct=inct+1
            if(inct.gt.isurmx)then
            write(*,*)'inct gt 15: too many surface hits'
            write(*,*)'l0 =',l0
            go to 98
            endif
           inorout(l0,inct)=j
           endif
444       continue
c-diag--- write(*,*)l0,(inorout(l0,i),i=1,inct)
c--finding surface depths-------------------
c---case for no surfaces---give it background or tomo-----
         if(inct.eq.0)goto 980
c---find appropriate surface depths-------------------
         do 600 i9=1,inct
         i=(inorout(l0,i9))
c---find valid surfaces-------------------
         do 813 l3=1,nlasur(i)-1
         if(rlat(l0).le.rlasur(i,l3).and.rlat(l0).gt.rlasur(i,l3+1))then
         do 824 l4=1,nlosur(i)-1
         if(rlon(l0).gt.rlosur(i,l4).and.rlon(l0).le.rlosur(i,l4+1))then
         rrt=(rlon(l0)-rlosur(i,l4))/(rlosur(i,l4+1)-rlosur(i,l4))
         rru=(rlat(l0)-rlasur(i,l3+1))/(rlasur(i,l3)-rlasur(i,l3+1))
c--note here rsuval indexes are (surface number, long, lat); in------
c-- lab model it was (lat,long)--------------------------------------
         rsuqus(l0,i9)=((1-rrt)*(1-rru)*rsuval(i,l4,l3+1))+(rrt*(1-rru)*
     1       rsuval(i,l4+1,l3+1))+(rrt*rru*rsuval(i,l4+1,l3))+((1-rrt)*
     2       rru*rsuval(i,l4,l3))
c-diag---write(*,*)l0,rsuqus(l0,i9)
          endif
824        continue
          endif
813      continue
600      continue
c -- correct some surfaces here for cases where know a surface should
c --always be below another-------------------------------------------
c --62 and 64 sometimes arsy-versy----
c --47 and 55 sometimes arsy-versy--
c --1, 57, and 50 sometimes arsy-versy--
c --1 and 56 sometimes arsy-versy
c --1 and 47 sometimes arsy-versy
c --65 and 63 sometimes arsy-versy
           iflag64=0
           iflag62=0
           iflag47=0
           iflag55=0
           iflag73=0
c A5 to A6 changes
           iflag01=0
           iflag50=0
           iflag56=0
           iflag57=0
           iflag65=0
           iflag63=0
c end A6 changes
           inum62=0
           inum64=0
           inum47=0
           inum55=0
           inum73=0
c A5 to A6 changes
           inum01=0
           inum50=0
           inum56=0
           inum57=0
           inum65=0
           inum63=0
c end A6 changes
           do 676 nx=1,inct
            if(inorout(l0,nx).eq.62)then
             iflag62=1
             inum62=nx
             rtemp62=rsuqus(l0,nx)
            endif
            if(inorout(l0,nx).eq.64)then
             iflag64=1
             inum64=nx
             rtemp64=rsuqus(l0,nx)
            endif
            if(inorout(l0,nx).eq.47)then
             iflag47=1
             inum47=nx
             rtemp47=rsuqus(l0,nx)
            endif
            if(inorout(l0,nx).eq.55)then
             iflag55=1
             inum55=nx
             rtemp55=rsuqus(l0,nx)
             if(rsuqus(l0,nx).lt.16.4)rsuqus(l0,nx)=0.
            endif
c A5 to A6 changes
            if(inorout(l0,nx).eq.65)then
             iflag65=1
             inum65=nx
             rtemp65=rsuqus(l0,nx)
            endif
            if(inorout(l0,nx).eq.63)then 
             iflag63=1 
             inum63=nx 
             rtemp63=rsuqus(l0,nx) 
            endif
            if(inorout(l0,nx).eq.1)then
             iflag01=1
             inum01=nx
             rtemp01=rsuqus(l0,nx)
            endif
            if(inorout(l0,nx).eq.50)then
             iflag50=1
             inum50=nx
             rtemp50=rsuqus(l0,nx) 
            endif
            if(inorout(l0,nx).eq.56)then 
             iflag56=1 
             inum56=nx 
             rtemp56=rsuqus(l0,nx) 
            endif
            if(inorout(l0,nx).eq.57)then 
             iflag57=1 
             inum57=nx 
             rtemp57=rsuqus(l0,nx) 
            endif
c end A6 changes
c need this for SGV velocity inversion
            if(inorout(l0,nx).eq.73)then
             inum73=nx
             iflag73=1
            endif
676        continue
c A5 to A6 changes
           if(iflag56.eq.1.and.iflag01.eq.1)then
            if(rtemp56.gt.rtemp01)then
             rsuqus(l0,inum01)=rtemp56
             rsuqus(l0,inum56)=rtemp01
            endif
           endif
           if(iflag57.eq.1.and.iflag50.eq.1)then
            if(rtemp50.gt.rtemp57)then
             rsuqus(l0,inum57)=rtemp50
             rsuqus(l0,inum50)=rtemp57
             rtemp57=rtemp50
            endif
           endif
           if(iflag01.eq.1.and.iflag57.eq.1)then
            if(rtemp57.gt.rtemp01)then
            rsuqus(l0,inum01)=rtemp57
            rsuqus(l0,inum57)=rtemp01
            endif 
           endif
           if(iflag65.eq.1.and.iflag63.eq.1)then
            if(rtemp65.gt.rtemp63)then
             rsuqus(l0,inum65)=rtemp63
             rsuqus(l0,inum63)=rtemp65
            endif
           endif
c end A6 changes
           if(iflag62.eq.1.and.iflag64.eq.1)then
            if(rtemp64.gt.rtemp62)then
             rsuqus(l0,inum64)=rtemp62
             rsuqus(l0,inum62)=rtemp64
            endif
           endif
           if(iflag55.eq.1.and.iflag47.eq.1)then
            rd55=(rtemp47-rtemp55)
c           if(rtemp55.eq.rtemp47)then
            if(rd55.lt.2..and.rd55.ge.0.)then
             rsuqus(l0,inum47)=rsuqus(l0,inum47)+32.8
             endif
            if(rtemp55.gt.rtemp47)then
             rsuqus(l0,inum55)=rtemp47
             rsuqus(l0,inum47)=rtemp55
c A5 to A6 change
             rtemp47=rtemp55
c end A6 change
            endif
           endif
c A5 to A6 change
           if(iflag01.eq.1.and.iflag47.eq.1)then
            if(rtemp47.gt.rtemp01)then
             rsuqus(l0,inum47)=rtemp01
             rsuqus(l0,inum01)=rtemp47
            endif
           endif
c end A6 change
c---check which surface is above------------------------------------
c---surface sign note: (+) are below sea level, (-) are above-------
c---check which surface is below------------------------------------
c--also, find shallowest surface-----
           rchk=rckval
           rchk2=rckval
           rshal=rckval
           iupflag=0
           iup=0
           idn=0
           ishal=0
           do 142 i8=1,inct
           rdelt=abs(rdep(l0)-rsuqus(l0,i8))
           rdelt2=abs(rsuqus(l0,i8)-rdep(l0))
           if(rdelt.lt.rchk.and.rsuqus(l0,i8).le.rdep(l0))then
            rchk=rdelt
            iup=(inorout(l0,i8))
            iupm=i8
            endif
           if(rdelt2.lt.rchk2.and.rdep(l0).lt.rsuqus(l0,i8))then
            rchk2=rdelt2
            idn=(inorout(l0,i8))
            idnm=i8
            endif 
           if(rsuqus(l0,i8).lt.rshal)then
            rshal=rsuqus(l0,i8)
            ishal=(inorout(l0,i8))
            endif
142        continue
c-diag---  write(*,*)l0, iup, idn, ishal
           if(iup.ne.0.and.idn.ne.0)goto 1177
c---hey, if at ground surface, won't find a surface above-----------
c---also, may be some 'holes', even at some depth, have a surface below---
c---but not above-------------------------
c--of course, expect this in LAB and SAN BERDO where have--
c--surface geology defined by polygons and not surfaces--
           if(iup.eq.0.and.idn.ne.0)then
c check for LAB and SMM and SAN BERDO ---99 is a flag---
            if(idn.ge.58)then
            iupflag=99
c--diag-----write(*,*)l0,iup,idn
            go to 1177
            endif
1188       iup=idn
           iupm=idnm
           ishal=idn
           goto 1177
           endif
c--in VENT and SFV can have case where at bottom of model but
c--no crystalline basement---so
c---check if current point below max control depths----------------
c ie for cases where found something above and nothing below
c--really need a separate surface for max depth control--
c--here, assign basement if > 2 km below control----
c--this takes care of single surface control
           if(iup.ne.0.and.idn.eq.0)then
c -- smm line H fix--
           if(iup.eq.64)go to 980
           rmaxck=rdep(l0)-rsuqus(l0,iupm)
           if(rmaxck.lt.6562.)then
           idn=iup
           idnm=iupm
           ishal=iup
           else
           go to 980
           endif
           endif
c----in crystalline basement use background velos-------------
c this is for: b1, b3,b4,b5, sbb2_sur,smb1_sur,smb2_sur,laba_sur
c---(recall incorrectly joined sfv b1 and vent b1)
1177       continue
c-b1 surface----------------------------------
           if(iup.eq.1)go to 980
c-b3 surface------------------------------------
           if(iup.eq.3)go to 980
c-b4 surface------------------------------------
           if(iup.eq.4)go to 980
c-b5 surface------------------------------------
           if(iup.eq.5)go to 980
c-sbb2_sur surface (aka sb_base2_sur_A)--------
           if(iup.eq.58)go to 980
c-sgba_sur surface (san gab valley basement)----
           if(iup.eq.72)go to 980
c--smb3 rules--and other smm rules-------
           if(iup.eq.71.and.idn.eq.67)then
            call getup(rlat(l0),rlon(l0),ruplc) 
            rupcor=amax1(ruplc,0.)
            rd01=0.
            rd02=rsuqus(l0,idnm)
            call getgeo(rlat(l0),rlon(l0),ragesur)
            ra1=ragesur
            ra2=rage(idn)
            rk1=rkall(idn)
            rk2=rkall(idn)
            rf1=rfacs(idn)
            rf2=rfacs(idn)
            rscal=(rdep(l0)-rd01)/(rd02-rd01)
            go to 9191
           endif
           if(iup.eq.71.and.idn.eq.65)then
           call getup(rlat(l0),rlon(l0),ruplc)
            rupcor=amax1(ruplc,0.)
            rd01=rsuqus(l0,iupm)
            rd02=rsuqus(l0,idnm)
            ra1=rage(67)
            ra2=rage(idn)
            rk1=rkall(67) 
            rk2=rkall(idn) 
            rf1=rfacs(67) 
            rf2=rfacs(idn)
            rscal=(rdep(l0)-rd01)/(rd02-rd01)
            go to 9191
           endif
           if(iup.eq.64.and.idn.eq.67)then
            call getup(rlat(l0),rlon(l0),ruplc)
            rupcor=amax1(ruplc,0.)
            rd01=0.
            rd02=rsuqus(l0,idnm)
            call getgeo(rlat(l0),rlon(l0),ragesur)
            ra1=ragesur
            ra2=rage(idn)
            rk1=rkall(idn) 
            rk2=rkall(idn) 
            rf1=rfacs(idn) 
            rf2=rfacs(idn)
            rscal=(rdep(l0)-rd01)/(rd02-rd01)
            go to 9191
           endif
           if(iup.eq.71.and.idn.eq.63)then
           call getup(rlat(l0),rlon(l0),ruplc)
            rupcor=amax1(ruplc,0.)
            rd01=rsuqus(l0,iupm)
            rd02=rsuqus(l0,idnm)
            ra1=rage(65)
            ra2=rage(idn)
            rk1=rkall(65) 
            rk2=rkall(idn) 
            rf1=rfacs(65) 
            rf2=rfacs(idn)
            rscal=(rdep(l0)-rd01)/(rd02-rd01)
            go to 9191
           endif
c -- fix for south sfv-north smm
c          if(iup.eq.55.and.idn.eq.55)go to 980
           if(iup.eq.47.and.idn.eq.47)go to 980
c -- between smm basement layers-------------
           if(iup.eq.62.and.idn.eq.71)go to 980
           if(iup.eq.62.and.idn.eq.63)go to 980
c -- fix for b3 over m1-----------------------
           if(iup.eq.71.and.idn.eq.64)then
            call getup(rlat(l0),rlon(l0),ruplc)
            rupcor=amax1(ruplc,0.)
            ra1=rage(64)
            ra2=rage(64)
            rk1=rkall(64) 
            rk2=rkall(64) 
            rf1=rfacs(64) 
            rf2=rfacs(64)
            rscal=1.
            go to 9191
           endif
c --- smm fix for between b9 and m2-for Line I
c change it to between b3 and m2 (as above)
c for line J this worked:if(iup.eq.62.and.idn.eq.65)go to 980
           if(iup.eq.62.and.idn.eq.65)then
            call getup(rlat(l0),rlon(l0),ruplc)
            rupcor=amax1(ruplc,0.)
            ra1=rage(67)
            ra2=rage(idn)
            rk1=rkall(67) 
            rk2=rkall(idn) 
            rf1=rfacs(67) 
            rf2=rfacs(idn)
             do 9988 i=1,inct
             if(inorout(l0,i).eq.71)then
c-- line J fix--
              if(rsuqus(l0,i).gt.rtemp62)go to 980
              rd01=rsuqus(l0,i)
              rd02=rsuqus(l0,idnm)
              go to 9989
             endif
9988         continue
              rd01=rsuqus(l0,iupm)
              rd02=rsuqus(l0,idnm)
9989        rscal=(rdep(l0)-rd01)/(rd02-rd01)
            go to 9191             
            endif
c-smb1_sur surface (aka smm_b1_sur)-b9 in this version--
           if(iup.eq.62.and.idn.eq.iup)go to 980
c-smb3_sur surface (aka smm_b1_sur)---------------------
           if(iup.eq.71.and.idn.eq.iup)go to 980
c-smb2_sur surface (aka smm_b2_sur)--------------
           if(iup.eq.63)go to 980
c-laba_sur surface (aka basement.ascii.B_no_num)--
           if(iup.eq.68)go to 980
c----assign reference depths------------rupcor is 'uplift'---------
c---------------------------------------rshcor is elev correction--
           if(rshal.lt.0.)then
           rshcor=abs(rshal)
           else
           rshcor=0.
           endif
c---need a top layer or not here--(top here)--------------
           if(iupflag.ne.99)then
            rupcor=(rupl(iup)-rdep(l0))
            if(rupcor.lt.0.)rupcor=0.
c---if in LAB, must look up uplift------------------------ 
            if(idn.ge.62)then 
             call getup(rlat(l0),rlon(l0),ruplc) 
             rupcor=amax1(ruplc,0.) 
            endif
            rd01=rsuqus(l0,iupm)
            rd02=rsuqus(l0,idnm)
           else
c---------------------------------(BERDO no top layer here)-----
            rupcor=0.
c-----------------------------------LAB, no top----------
            if(idn.ge.62)then
             call getup(rlat(l0),rlon(l0),ruplc)
             rupcor=amax1(ruplc,0.)
            endif
             rd01=0.
             rd02=rsuqus(l0,idnm)
           endif 
c----assign reference ages-------(no surface geology)---------------
           if(iupflag.ne.99)then
            ra1=rage(iup)
            ra2=rage(idn)
            rk1=rkall(iup) 
            rk2=rkall(idn) 
            rf1=rfacs(iup) 
            rf2=rfacs(idn)
c---------------------------------(must look up surface geology)---
            else
            call getgeo(rlat(l0),rlon(l0),ragesur)
            ra1=ragesur
            ra2=rage(idn)
            rk1=rkall(idn) 
            rk2=rkall(idn) 
            rf1=rfacs(idn) 
            rf2=rfacs(idn)
           endif
c---interpolate age from strat--------------------------------------
c--------(get rscal without uplift)---------------------------------
          if(iup.ne.idn)then
          rscal=(rdep(l0)-rd01)/(rd02-rd01)
          else
          rscal=1.
          endif
c----scale sed age, define final depth------------
9191      rtage=(rscal*ra2)+((1.-rscal)*ra1)
          rtdep=rdep(l0)+rupcor+rshcor
c----scale constant, exponent---------------------
          rk=(rscal*rk2)+((1.-rscal)*rk1)
          rfac=(rscal*rf2)+((1.-rscal)*rf1)
c---find alpha in ft/s---------------------------------------------
          alpha(l0)=rk*(rtdep**rfac)*(rtage**rfac)
c---San Gabriel Valley velocity inversion--SGV---------------------
c 1280 ft (about 390 m) is depth over inversion of
c 4087 ft/s is tapered in
c 0.6 of mohnian depth is where inversion occurs
c         if(idn.ge.72.and.idn.le.74)then
          if(idn.ge.72)then
          if(iflag73.eq.1)then
           rsgvck=0.6*rsuqus(l0,inum73)
           if(rdep(l0).gt.rsgvck)then
            rsgv2=(rdep(l0)-rsgvck)/1280.
            if(rsgv2.gt.1.)rsgv2=1.0
c           rdelve=sin((rsgv2*1.570796327))*4087.
            rdelve=(exp(rsgv2)/2.718281828)*4087.
            alpha(l0)=alpha(l0)-rdelve
c           if(idn.eq.74)alpha(l0)=alpha(l0)-2414.
c           if(idn.eq.73)alpha(l0)=alpha(l0)-4087.
c           if(idn.eq.72)alpha(l0)=alpha(l0)-4087.
           endif
          endif
          endif
          go to 799
c--- assign regional model. or,
c--put tomo look up here---------------
c-- data in arrays rbv,rbi, number layers=nlayrb--------------------
980      if(rdep(l0).lt.0.)then
          alpha(l0)=rbv(1)
          else if(rdep(l0).ge.rbi(nlayrb))then
          alpha(l0)=rbv(nlayrb)
          else
          do 650 i=1,nlayrb-1
          if(rdep(l0).ge.rbi(i).and.rdep(l0).lt.rbi(i+1))then
           rscabg=(rdep(l0)-rbi(i))/(rbi(i+1)-rbi(i))
           rvup=rbv(i)
           rvdn=rbv(i+1)
c this line puts in velocity jump at 32 km depth
           if(i.eq.3)rvup=25586.184
           alpha(l0)=(rscabg*rvdn)+((1.-rscabg)*rvup)
          endif
650       continue
         endif
c Below assigns Hadley-Kanamori----------
c-- data in arrays rbv,rbi, number layers=nlayrb--------------------
c-- KLM replaced simple Hadley-Kanamori model with a gradient model-
c-- gradient model has the same vertical travel time----------------
c-- only upper two layers have gradients rbv1-----------------------
c----this assumes rdep is in increasing order in input file------------
c980      if(rdep(l0).lt.0.)then
c         alpha(l0)=rbv(1)
c         else
c         do 650 i=1,nlayrb
c         if(rdep(l0).ge.rbi(i))then
c          alpha(l0)=rbv(i)+rbv1(i)*(rdep(l0)-rbi(i))
c          endif
c650      continue
c         endif
c----convert alpha to m/s-------------------------------------------
799       alpha(l0)=alpha(l0)*0.30480
          write(27,*)l0,alpha(l0),iup,idn,(rsuqus(l0,i),
     1    inorout(l0,i),i=1,inct)
c---clamp here if wanted---------------------------------
c clamp for beta=1.0 km/s
c         if(alpha(l0).lt.2414.)alpha(l0)=2414.
c clamp for beta =0.5 km/s
c         if(alpha(l0).lt.1225.)alpha(l0)=1225.
c---find rho---------------------------------------------------------
c --see lab model for citations--------------------------------------
c--assume density in case of velocity lt 1500 m/s--------------------
         rho(l0)=1000.
c--for velocities 1500 to 1625 m/s----------------------------------------
         if(alpha(l0).ge.1500.)rho(l0)=(alpha(l0)*5.8971675)-7853.4328
c--for velocities 1625 to 2500 m/s--------------------------------------- 
         if(alpha(l0).gt.1625.)rho(l0)=(alpha(l0)*.444174)+1000.
c--for velocities 2500 to 7000 (and above) m/s--------------------------
         if(alpha(l0).gt.2500.)rho(l0)=(alpha(l0)*.17333)+1695.65
c------ find beta----------------------------------------------------------
c --see lab model for citations--------------------------------------
         sigma=0.40
         if(rho(l0).ge.2060.)sigma=.40-((rho(l0)-2060.)*.00034091)
         if(rho(l0).gt.2500.)sigma=0.25
         beta(l0)=alpha(l0)/(sqrt((1.-sigma)/(.5-sigma)))
c----------------------------------------------------------------------
c end main loop---------------------------------------------------------
800      continue
c----------postpro here if wanted-----------------------------
c        call postpro
c-----------------------------
c write out points and values
         call writepts(kerr)
98       stop
         end



c-----reads strat surface edges---------------
         subroutine readedge(kerr)
c---reads x-y pairs--------------------------
         include 'surface.h'
         character*9 aname2, asuf2*5
         include 'names.h'
         asuf2='_edge'
         kerr=0
c-------------------------------
         do 217 i=1,numsur
          aname2=aedname(i)//asuf2
          open(17,file=aname2,status='old',err=299)
           do 218 j=1,nedge(i)
           read(17,*)rtx(i,j),rty(i,j)
218        continue
          close(17)
217       continue
         go to 201
299      kerr=1
         write(*,*)aname2,i
201      return
         end

c-----read model edge file, kept separate from surface edge-----
c-------to simplify index counts--------------------------------
           subroutine modedge(kerr)
          include 'surface.h'
          character*9 aname3
          kerr=0
c---file name assignment-------
          aname3='bmod_edge'
c----i3=number of xy pairs-------
          open(18,file=aname3,status='old',err=259)
c        read(18,*)i3   !i3 now set at top
         do 511 i=1,i3
         read(18,*)rmodtx(i),rmodty(i)
511      continue
         close(18)
         go to 291
259      kerr=1
291      return
         end

         subroutine readgeo(k2err)
c reads geologic contours
         include 'sgeo.h'
         character*16 fileii,a1*10
         include 'sgeod.h'
c---file name assignment-------
         fileii='lab_geo2_geology'
         k2err=0
c read file
           open(12,file=fileii,type='old',err=977)
           do 300 k=1,ngeo
           read(12,*)np(k)
            do 310 k1=1,np(k)
            read(12,*)rloi(k,k1),rlai(k,k1)
310         continue
c skip label line. Label follows lat-long points
            read(12,*)a1
300        continue
           close(12)
           go to 976
977        k2err=1
976        return
           end

c---------get surface geology age-----------
          subroutine getgeo(rlatl0,rlonl0,ragesur)
c
c finds surface age from surface geology
c looks inside geology contours for hit.
c contours are crudely digitized, so if no hit, uses closest point
         include 'sgeo.h'
         dimension rdelt(ngeo,ngeo2),xv(ngeo2),yv(ngeo2)
c        include 'sgeod.h'
           iflag=5
           rdmin=100.
           rd2rad=3.141593/180.
c look inside
           do 400 j=1,ngeo
           xref=rloi(j,np(j))
           yref=rlai(j,np(j))
           reflat=yref*rd2rad
            do 410 i=1,np(j)
            yv(i)=(rlai(j,i)-yref)*111.1
            xv(i)=(rloi(j,i)-xref)*111.1*cos(reflat)
410         continue
           rxp=(rlonl0-xref)*111.1*cos(reflat)
           ryp=(rlatl0-yref)*111.1
           call inside(rxp,ryp,xv,yv,np(j),ins)
           if(ins.eq.1)then
           ragesur=ra(j)
           go to 199
           endif
400        continue
c okay, missed, use backup-nearest contour point defines it
           do 500 l=1,ngeo
            do 510 l2=1,np(l)
            rlodif=(rlonl0-rloi(l,l2))*92.3820
            rladif=(rlatl0-rlai(l,l2))*110.9220
            rdelt(l,l2)=sqrt((rlodif**2.)+(rladif**2.))
            if(rdelt(l,l2).lt.rdmin)then
            rdmin=rdelt(l,l2)
            iflag=l
            endif
510         continue
500        continue
           ragesur=ra(iflag)
           go to 199
c
199        return
           end

c---reads stratigraphic surfaces-------------------------
         subroutine readsurf(kerr)
c---reads spyglass ascii output--------------------------
         include 'surface.h'
         character*8 aname, asuf*4
         include 'names.h'
         asuf='_sur'
         kerr=0
c---loop to read-------------------
         do 117 i=1,numsur
          aname=aedname(i)//asuf
          open(16,file=aname,status='old',err=99)
          read(16,*)(rlosur(i,j),j=1,nlosur(i))
           do 118 k=1,nlasur(i)
           read(16,*)rlasur(i,k),(rsuval(i,j,k),j=1,nlosur(i))
c---For VENT and SFV (i <= 57) convert depth meters to feet-------
            if(i.le.57)then
            do 119 n=1,nlosur(i)
            rsuval(i,n,k)=rsuval(i,n,k)*3.28084
119         continue
            endif
c---For LAB (i=68,69,70) convert depth thousands of feet to feet---
            if(i.ge.68.and.i.le.70)then
            do 1199 n=1,nlosur(i)
            rsuval(i,n,k)=rsuval(i,n,k)*1000.
1199        continue
            endif
c---For SGV (i=72,73,74) convert depth thousands of feet to feet---
            if(i.ge.72.and.i.le.74)then
            do 1999 n=1,nlosur(i)
            rsuval(i,n,k)=rsuval(i,n,k)*1000.
1999        continue
            endif
118        continue           
         close(16)
117      continue
         go to 101
99       kerr=1
101      return
         end

c-reads uplift file for LAB--------------------
        subroutine readup(kerr)
c-----just like readsur-------------
        include 'labup.h'
        character*8 filei4
c file name assignment
        filei4='laup_sur'
c
        open(16,file=filei4,status='old',err=99)
c
         do 400 i=1,nlaup 
          read(16,*) rlaup(i),(rzupl(i,j),j=1,nloup) 
          do 440 j=1,nloup
c convert thousands of feet to feet---------------
          rzupl(i,j)=rzupl(i,j)*1000. 
440       continue 
400      continue  
         close(16)
         go to 101
99       kerr=1
101      return
         end

c--gets uplift for LAB---------------
        subroutine getup(rlatl0,rlonl0,ruplc)
c find uplift amount at current lat long
        include 'labup.h'
877        do 817 l7=1,nlaup-1
           if(rlatl0.le.rlaup(l7).and.rlatl0.gt.rlaup(l7+1))then
            do 828 l8=1,nloup-1 
            if(rlonl0.gt.rloup(l8).and.rlonl0.le.rloup(l8+1))then
            rmt=(rlonl0-rloup(l8))/(rloup(l8+1)-rloup(l8))
            rmu=(rlatl0-rlaup(l7+1))/(rlaup(l7)-rlaup(l7+1))
            ruplc=((1-rmt)*(1-rmu)*rzupl(l7+1,l8))+(rmt*(1-rmu)*
     1       rzupl(l7+1,l8+1))+(rmt*rmu*rzupl(l7,l8+1))+((1-rmt)*
     2       rmu*rzupl(l7,l8)) 
            go to 899 
            endif    
828        continue 
           endif   
817       continue
          ruplc=0.  
899       return
          end
c
        subroutine inside (xp,yp,xv,yv,n,ins)
        dimension xv(n),yv(n)
        nleft=0
        x2=xv(n)
        y2=yv(n)
        do 14 j1=1,n
        x1=x2
        y1=y2
        x2=xv(j1)
        y2=yv(j1)
        if(amin1(y1,y2).ge.yp) goto 14
        if(amax1(y1,y2).lt.yp) goto 14
        if (y1.eq.y2) goto 27
        xi=x1+(yp-y1)*(x2-x1)/(y2 -y1)
        if(xi.eq.xp) goto 17
        if(xi.gt.xp) nleft=nleft+1
        goto 14
   27   if(xp.gt.amax1(x1,x2)) goto 14
        if(xp.ge.amin1(x1,x2)) goto 17
        nleft=nleft+1
   14   continue
        ins=mod(nleft,2)
        return
   17   ins=1
        return
        end
c
c
        subroutine postpro
c POST PROcessing for LAB model
c continues velocities out from realm of
c credibility to beyond
         include 'in.h'
c
c linear interpolation distance rinterp
c    - KLM -
c
         rinterp = 5.0
c continue those outside realm
         do 556 n=1,nn
         if(inout(n).ne.1)then
c
c save the regional model
c   - KLM -
c
          alpha1 = alpha(n)
          beta1 = beta(n)
          rho1 = rho(n)
c look for closest point inside
          rdmin=300.
          do 557 n2=1,nn
          if(inout(n2).ne.1)go to 557
          if(rdep(n2).ne.rdep(n))go to 557
          rlodif=(rlon(n2)-rlon(n))*92.3820
          rladif=(rlat(n2)-rlat(n))*110.9220
c          rdelt=sqrt((rlodif**2.)+(rladif**2.))
c replaced L2 norm with L1 norm to make things faster
c    -  KLM -
c
          rdelt=abs(rlodif)+abs(rladif)
          if(rdelt.lt.rdmin)then
          rdmin=rdelt
          alpha(n)=alpha(n2)
          rho(n)=rho(n2)
          beta(n)=beta(n2)
          endif
557       continue
          endif
c
c do a linear interpolation from closest inside point to regional model
c   - KLM -
c
          if(inout(n).eq.1)go to 556
          if( rdmin .gt. rinterp ) then
              alpha(n) = alpha1
              rho(n) = rho1
              beta(n) = beta1
          else if( rdmin .le. rinterp ) then
              alpha(n) = alpha(n) + (alpha1-alpha(n))*rdmin/rinterp
              beta(n) = beta(n) + (beta1-beta(n))*rdmin/rinterp
              rho(n) = rho(n) + (rho1-rho(n))*rdmin/rinterp
          endif
556      continue
         return
         end

c-----read points of interest-----------------
         subroutine readpts(kerr)
         include 'in.h'
         kerr=0
         open(15,file='btestin',status='old',err=1099) 
c        nn=51456
         read(15,*)nn 
         do 150 i=1,nn 
         read(15,*)rlat(i),rlon(i),rdep(i) 
         if(rdep(i).lt.rdepmin)rdep(i)=rdepmin 
150      continue 
         close(15)
         go to 1088
1099     kerr=1
1088     return
         end
 
c----write points of interest-----------------
         subroutine writepts(kerr)
         include 'in.h'
         kerr=0
         open(17,file='btestout',status='new')
         do 155 i=1,nn
          write(17,77)rlat(i),rlon(i),rdep(i),alpha(i)
     1    ,beta(i),rho(i)
77       format(f8.5,1x,f10.5,1x,f9.2,1x,f8.1,1x,f8.1,1x,f8.1)
155      continue
         close(17)
         return
         end



